﻿ /**
    ■ドキュメントのカンバスサイズをアルファマスクの範囲から任意の倍数に変換するスクリプト　v210124
　　　表示状態のレイヤーからアルファマスクを作成後マスクが0の範囲を外枠に1pix追加し
　　　その数値より大きく、もっとも近い任意の倍数の数値（2の冪数）にキャンバスサイズに変更する
　　　サイズの増減および増減方向は任意に対応
　▼構造前提条件
        最上段はレイヤーセットを親としている構成である
        カラーモードはRGBのみ対応
  */
//ドキュメントの各種定義
var docObj = activeDocument;//ドキュメント
docObj.activeLayer = docObj.layers[0];//active化
//定数
const defNum = {
    nonBGcolor:220/255,
    nonTextcolor:150/255,
    BGcolor:252/255, 
    Textcolor:0/255,
    Textcolor220:220/255,
    Textcolor185:185/255,
};
const defStr = {
    btnTL:"原点:上段左",
    btnTC:"原点:上段中央",
    btnTR:"原点:上段右",
    btnML:"原点:中段左",
    btnMC:"原点:中段中央",
    btnMR:"原点:中段右",
    btnBL:"原点:下段左",
    btnBC:"原点:下段中央",
    btnBR:"原点:下段右",
    info1TL:"右辺と下辺が増減し変動します",
    info1TC:"左右辺と下辺が増減し変動します",
    info1TR:"左辺と下辺が増減し変動します",
    info1ML:"右辺と上下辺が増減し変動します",
    info1MC:"左右上下辺が増減し変動します",
    info1MR:"左辺と上下辺が増減し変動します",
    info1BL:"右辺と上辺が増減し変動します",
    info1BC:"左右辺と上辺が増減し変動します",
    info1BR:"左辺と上辺が増減し変動します",
    info2Cmn:"のobujeとの相対的な距離は変更しません",
    info2TL:"注意：左辺と上辺",
    info2TC:"注意：上辺",
    info2TR:"注意：右辺と上辺",
    info2ML:"注意：左辺",
    info2MC:"注意：obujeサイズが奇数のとき半ピクセルずれる場合があります",
    info2MR:"注意：右辺",
    info2BL:"注意：左辺と下辺",
    info2BC:"注意：下辺",
    info2BR:"注意：右辺と下辺",
    info1Power:"サイズを2の冪数（2の累乗数）限定にします",
    info2Power:"2の冪：2 4 8 16 32 64 128 256 512 1024 2048…",
    info1PowerOff:"サイズを指定したカンバスサイズの倍数の値にします",
    info2PowerOff:"",
    multiple:"幅（w）高（ｈ）　カンバスサイズの倍率　　　X",
    power:"2の冪数に限定する　",
    square:"幅と高さを同じ数値にする",
    aChannel:"ｱﾙﾌｧﾁｬﾝﾈﾙ 1",
    resultTitle1:"■元のサイズ                　　   幅：",
    resultTitle2:" pixel　　　高さ：",
    newSize:"変更後のサイズ        ",
    width:"　幅：",
    height:"高さ： ",
    pix:" pixel ",
    ok:"OK",
    cancel:"Cancel", 
};
//変数定義
var CaseSensitiveFlg = true; //大文字小文字の判定
var consecutiveFlg = false;//連番の判定
var FindModeFlg = "";
var addNum =0;
var tmpMultiple = 8;
var whNGFlag = false;
var firstFlag = false;
var powerFlag = false;
var squareFlag = false;
//カンバスアンカー
var anchorPos = 0;
var anchorP = new Array();
anchorP[0] = AnchorPosition.TOPLEFT;
anchorP[1] = AnchorPosition.TOPCENTER;
anchorP[2] = AnchorPosition.TOPRIGHT;
anchorP[3] = AnchorPosition.MIDDLELEFT;
anchorP[4] = AnchorPosition.MIDDLECENTER;
anchorP[5] = AnchorPosition.MIDDLERIGHT;
anchorP[6] = AnchorPosition.BOTTOMLEFT;
anchorP[7] = AnchorPosition.BOTTOMCENTER;
anchorP[8] = AnchorPosition.BOTTOMRIGHT;
var x = y = 0; 
var oldX = oldY = 0;
var x1 = y1 = x2 = y2 = 0;
var whS = new Array();
var size={
    centerOldX:0,
    centerOldY:0,
    centerX:0,
    centerY:0,
};
var bound={
    centerOldX:0,
    centerOldY:0,
    centerX:0,
    centerY:0,
    sizeX:0,
    sizeY:0,
};
app.activeDocument.suspendHistory("script：Act_docResize_multiple", "Act_docResize_multiple()");
function Act_docResize_multiple(){
	//ダイアログ追加
	var dialog = new Window("dialog",'Act_docResize_multiple',);
	//原点選択
	var posPanel01 = dialog.add("group");
    posPanel01.orientation = "row";
    posPanel01.alignChildren = "center";
    posPanel01.BtnPosL = posPanel01.add("radiobutton",undefined,defStr.btnTL);
    posPanel01.BtnPosC = posPanel01.add("radiobutton",undefined,defStr.btnTC);
    posPanel01.BtnPosR = posPanel01.add("radiobutton",undefined,defStr.btnTR);
    var posPanel02 = dialog.add("group");
    posPanel02.orientation = "row";
    posPanel02.alignChildren = "center";
    posPanel02.BtnPosL = posPanel02.add("radiobutton",undefined,defStr.btnML);
    posPanel02.BtnPosC = posPanel02.add("radiobutton",undefined,defStr.btnMC);
    posPanel02.BtnPosR = posPanel02.add("radiobutton",undefined,defStr.btnMR);
    var posPanel03 = dialog.add("group");
    posPanel03.orientation = "row";
    posPanel03.alignChildren = "center";
    posPanel03.BtnPosL = posPanel03.add("radiobutton",undefined, defStr.btnBL);
    posPanel03.BtnPosC = posPanel03.add("radiobutton",undefined,defStr.btnBC);
    posPanel03.BtnPosR = posPanel03.add("radiobutton",undefined, defStr.btnBR);
    //処理選択初期設定
    posPanel02.BtnPosC.value = true;
    //上段処理
    posPanel01.BtnPosL.onClick = function (){
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1TL;
        txtPanel.info02.text =defStr.info2TL + defStr.info2Cmn;
    };
    posPanel01.BtnPosC.onClick = function (){
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1TC;
        txtPanel.info02.text =defStr.info2TC + defStr.info2Cmn;
    };
    posPanel01.BtnPosR.onClick = function (){
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1TR;
        txtPanel.info02.text =defStr.info2TR + defStr.info2Cmn;
    };
    //中段処理
    posPanel02.BtnPosL.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1ML;
        txtPanel.info02.text =defStr.info2ML + defStr.info2Cmn;
    };
    posPanel02.BtnPosC.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1MC;
        txtPanel.info02.text =defStr.info2MC;
    };
    posPanel02.BtnPosR.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel03.BtnPosL.value = false;
        posPanel03.BtnPosC.value = false;
        posPanel03.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1MR;
        txtPanel.info02.text =defStr.info2MR + defStr.info2Cmn;
    };
    //下段処理
    posPanel03.BtnPosL.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1BL;
        txtPanel.info02.text =defStr.info2BL + defStr.info2Cmn;
    };
    posPanel03.BtnPosC.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1BC;
        txtPanel.info02.text =defStr.info2BC + defStr.info2Cmn;
    };
    posPanel03.BtnPosR.onClick = function (){
        posPanel01.BtnPosL.value = false;
        posPanel01.BtnPosC.value = false;
        posPanel01.BtnPosR.value = false;
        posPanel02.BtnPosL.value = false;
        posPanel02.BtnPosC.value = false;
        posPanel02.BtnPosR.value = false;
        txtPanel.info01.text =defStr.info1BR;
        txtPanel.info02.text =defStr.info2BR + defStr.info2Cmn;
    };
    var customPanel01 = dialog.add("group");
    customPanel01.orientation = "row";
    customPanel01.alignChildren = "center";
    customPanel01.sTextM　= customPanel01.add("statictext",undefined,defStr.multiple);
    customPanel01.sizeM = customPanel01.add("edittext",undefined, tmpMultiple);
    
    var customPanel02 = dialog.add("group");
    customPanel02.orientation = "row";
    customPanel02.alignChildren = "center";
    powerCheck = customPanel02.add("checkbox",undefined,defStr.power);
    
    powerCheck.onClick = function (){
        if(powerCheck.value){
            txtPanel.info01.text =defStr.info1Power;
            txtPanel.info02.text =defStr.info2Power;
            tmpMultiple = parseInt(customPanel01.sizeM.text);
            customPanel01.sizeM.text = "2";
            powerFlag = true;
        } else {
            txtPanel.info01.text  = defStr.info1PowerOff;
            txtPanel.info02.text  = defStr.info2PowerOff;
            customPanel01.sizeM.text = tmpMultiple  +"";
            powerFlag = false;
        }
    }        
    //info
    var group1 = dialog.add("group");
    group1.alignment = [ScriptUI.Alignment.CENTER,ScriptUI.Alignment.CENTER];
    group1.Pnl = group1.add("panel",undefined, "■Information");    
     var txtPanel = group1.Pnl.add("group");
    txtPanel.orientation = "column";
    txtPanel.alignChildren = "left";
    txtPanel.info01 = txtPanel.add("statictext", undefined, defStr.info1MC + "　　　　　　　　　　　　　　　　　　");
    txtPanel.info02 = txtPanel.add("statictext", undefined, defStr.info2MC + "　");
    txtPanel.info02.graphics.foregroundColor =
        txtPanel.info02.graphics.newPen(txtPanel.info02.graphics.PenType.SOLID_COLOR, [defNum.Textcolor220, defNum.nonTextcolor, defNum.nonTextcolor],1);

	//ボタン
	var buttons = dialog.add("group");
	buttons.orientation = "row";
	buttons.alignment = "center";
	var okBtn = buttons.add("button");
	okBtn.text = defStr.ok;
	okBtn.properties = {name: "ok"};
	var cancelBtn = buttons.add("button");
	cancelBtn.text = defStr.cancel;
	cancelBtn.properties = {name: "cancel"};
	//レイアウト
	dialog.center();
	try{
		//OKを押した時のみ実行
		if (dialog.show() == 1) {
			//条件判定
			if(posPanel01.BtnPosL.value == true){
                    FindModeFlg = "TL";
			} else if(posPanel01.BtnPosC.value == true){
                    FindModeFlg = "TC";
			} else if(posPanel01.BtnPosR.value == true){
                    FindModeFlg = "TR";
			} else if(posPanel02.BtnPosL.value == true){
                    FindModeFlg = "ML";
			} else if(posPanel02.BtnPosC.value == true){
                    FindModeFlg = "MC";
			} else if(posPanel02.BtnPosR.value == true){
                    FindModeFlg = "MR";
			} else if(posPanel03.BtnPosL.value == true){
                    FindModeFlg = "BL";
			} else if(posPanel03.BtnPosC.value == true){
                    FindModeFlg = "BC";
			} else if(posPanel03.BtnPosR.value == true){
                    FindModeFlg = "BR";
             };
            tmpMultiple = parseInt(customPanel01.sizeM.text);
            new GetBounds();
            new SizeSwitch();
           
            if(FindModeFlg == "MC"){
                bound.centerX = size.centerOldX - bound.centerOldX;
                bound.centerY = size.centerOldY - bound.centerOldY;
                MoveCenter(bound.centerX,bound.centerY);
            };
            if(FindModeFlg == "TC" || FindModeFlg == "BC"){
                bound.centerX = size.centerOldX - bound.centerOldX;
                bound.centerY = 0;
                MoveCenter(bound.centerX,bound.centerY);
            };
            if(FindModeFlg == "ML" || FindModeFlg == "MR"){
                bound.centerX = 0;
                bound.centerY = size.centerOldY - bound.centerOldY;
                MoveCenter(bound.centerX,bound.centerY);
            };
            new ResizeSwitch();
            new SizeSwitch();
            new Ach();
            new Result();
		}else{
		};
	}catch(e) {
		alert("error("+e+")");
	};
};

//関数:検出したサイズの振り分け
function SizeSwitch(){
    if(!firstFlag){
        whS = new DocSize ();
        oldX = whS[0];
        oldY = whS[1]; 
        size.centerOldX = oldX /2;
        size.centerOldY = oldY /2;
        firstFlag = true;
        }else{
        whS = new DocSize();
        x = whS[0];
        y = whS[1];
        size.centerX = x /2;
        size.centerY = y /2;
    };
};
//関数：ドキュメントのサイズの検出
function DocSize(){
    //ドキュメントの横幅縦幅検出
    preferences.rulerUnits = Units.PIXELS;
    var w = activeDocument.width.value;
    var h = activeDocument.height.value;
    var whSize = new Array();
    whSize[0] = w;
    whSize[1] = h;
        if(firstFlag){
            if(powerFlag){
                var tmpX = whSize[0] = PowerCheck(w);
                var tmpY = whSize[1] = PowerCheck(h);
                new Resize(anchorPos,tmpX,tmpY);
            }else{            
            //倍数か診断
                var w = Math.round(w) % tmpMultiple;
                var h =Math.round(h) % tmpMultiple;
                if(w != 0 || h != 0){
                   whNGFlag = true;
                   var tmpX = whSize[0] = whSize[0]  +(tmpMultiple - w);
                   var tmpY = whSize[1] = whSize[1] +(tmpMultiple - h);
                   if(w == 0){
                        tmpX = whSize[0] ;                        
                   };
                   if(h == 0){
                        tmpY = whSize[1];                        
                   };
                  new Resize(anchorPos,tmpX,tmpY);
               };
           };
    };
    return whSize;
};

//関数：冪数と比較
function PowerCheck(num){
    var trigger = 1;
    var i =0;
    var Power;
    while (trigger > 0){
        i += 1;
        Power = Math.pow( 2 , i ) ;
        trigger = num - Power;
    };
    return Power;
};

//関数：アルファチャンネル初期化
function Ach(){
    var aNum = activeDocument.channels.length;
    //不要なアルファチャンネルを削除
    var colMode = activeDocument.mode;                
    if(colMode == DocumentMode.RGB){
        if(aNum>3){
                for (var i = aNum-1; i >= 3 ; i--){
                    activeDocument.channels[i].remove();
                };
        };
    };
    var  chObj = activeDocument.channels.add();
    chObj.name = defStr.aChannel;
};
//関数：親レイヤーのピクセル範囲を取得
function GetBounds(){
    activeDocument.activeLayer = activeDocument.layers[0];//active化
    activeDocument.activeLayer.duplicate();
    activeDocument.layers[0].merge();
    layBounds = activeDocument.layers[0].bounds;
    x1 = parseInt(layBounds[0]);
    y1 = parseInt(layBounds[1]);
    x2 = parseInt(layBounds[2]);
    y2 = parseInt(layBounds[3]);

    bound.sizeX = (x2 - x1)/2;
    bound.sizeY = (y2 - y1)/2;
    bound.centerOldX = bound.sizeX + x1;
    bound.centerOldY = bound.sizeY + y1;
    activeDocument.layers[0].remove();    
};

//関数：カンバスの増減分岐
function ResizeSwitch(){
    switch(FindModeFlg){
        case "TL":
            anchorPos = 0;
            var tmpX = x2 +1;
            var tmpY = y2 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "TC":
            anchorPos = 1;
            var tmpX = x2 - x1 +2;
            var tmpY = y2 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "TR":
            anchorPos = 2;     
            var tmpX = oldX - x1 +1;
            var tmpY = y2 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "ML":
            anchorPos = 3;
            var tmpX = x2 +1;
            var tmpY = y2 - y1 +2;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "MC":
            anchorPos = 4;
            var tmpX = x2 - x1 +2;
            var tmpY = y2 - y1 +2;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "MR":
            anchorPos =5;     
            var tmpX = oldX - x1 +1;
            var tmpY = y2 - y1 +2;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "BL":
            anchorPos = 6;
            var tmpX = x2 +1;
            var tmpY = oldY - y1 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "BC":
            anchorPos = 7;
            var tmpX = x2 - x1 +2;
            var tmpY = oldY - y1 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
        case "BR":
            anchorPos =8;     
            var tmpX = oldX - x1 +1;
            var tmpY = oldY - y1 +1;
            new Resize(anchorPos,tmpX,tmpY);break;
    };
};
//関数：カンバス増減
function Resize(anchorPos,tmpX,tmpY){
    preferences.rulerUnits = Units.PIXELS;
    activeDocument.resizeCanvas(tmpX,tmpY,anchorP[anchorPos]);
};
//関数：オブジェを中央へ移動
function MoveCenter(x,y){
    docObj.activeLayer.translate(x,y);
};
//ResultWindow
function Result(){
	//ダイアログ追加
	var dialog = new Window("dialog",'Result',);
    dialog.Pnl = dialog.add("panel",undefined,defStr.resultTitle1 + oldX + defStr.resultTitle2 + oldY + defStr.pix);
    //info 
    var txtPanel = dialog.Pnl.add("group");
    txtPanel.title02 = txtPanel.add("statictext", undefined, defStr.newSize);
    txtPanel.title02.graphics.font = ScriptUI.newFont ("Meiryo UI",ScriptUI.FontStyle.BOLD,12);
    txtPanel.title02.graphics.foregroundColor =
    txtPanel.title02.graphics.newPen(txtPanel.title02.graphics.PenType.SOLID_COLOR, [defNum.Textcolor, defNum.Textcolor185, defNum.Textcolor220],1);
    txtPanel.newx = txtPanel.add("statictext", undefined, defStr.width + x + defStr.pix);
    txtPanel.newy = txtPanel.add("statictext", undefined, defStr.height + y + defStr.pix);
    
    txtPanel.newx.graphics.font = ScriptUI.newFont ("Meiryo UI",ScriptUI.FontStyle.BOLD,12);
    txtPanel.newx.graphics.foregroundColor =
    txtPanel.newx.graphics.newPen(txtPanel.newx.graphics.PenType.SOLID_COLOR, [defNum.Textcolor, defNum.Textcolor185, defNum.Textcolor220],1);

    txtPanel.newy.graphics.font = ScriptUI.newFont ("Meiryo UI",ScriptUI.FontStyle.BOLD,12);
    txtPanel.newy.graphics.foregroundColor =
    txtPanel.newy.graphics.newPen(txtPanel.newy.graphics.PenType.SOLID_COLOR, [defNum.Textcolor, defNum.Textcolor185, defNum.Textcolor220],1);
	//ボタン
	var buttons = dialog.add("group");
	buttons.orientation = "row";
	buttons.alignment = "center";
	var okBtn = buttons.add("button");
	okBtn.text = defStr.ok;
	okBtn.properties = {name: "ok"};
	//レイアウト
	dialog.center();
    dialog.show();
};